<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" >
      <el-form-item label="二维码名称:" prop="name">
        <el-input
          v-model.trim="queryParams.name"
          placeholder="请输入身份信息"
          clearable
          size="small"
          style="width: 140px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item class="right">
        <el-button plain size="mini" @click="resetQuery">重置</el-button>
        <el-button type="primary"  size="mini" @click="handleQuery">搜索</el-button>
      </el-form-item>
      <br>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:admin:add']"
        >新增</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="adminList" @selection-change="handleSelectionChange" border>
      <el-table-column label="序号" align="left" prop="" show-overflow-tooltip >
        <template slot-scope="scope">
         {{scope.$index + 1}}
        </template>
      </el-table-column>
      <el-table-column label="二维码名称" align="left" prop="name"  show-overflow-tooltip />
      <el-table-column label="渠道名称" align="left" prop="topChannelName" show-overflow-tooltip />
      <el-table-column label="二维码" align="left" prop="qrPath" show-overflow-tooltip  >
        <template slot-scope="scope" >
          <el-image
            v-if="scope.row.qrPath"
            style="width: 100px; height: 100px"
            :preview-src-list="[scope.row.qrPath]"
            :src="scope.row.qrPath">
          </el-image>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="left" prop="createTime"  show-overflow-tooltip >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="left" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            class="lans"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:admin:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            class="hongs"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:admin:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />

    <!-- 添加或修改参数配置对话框 -->
    <el-dialog  :title="title" :visible.sync="open" width="500px" append-to-body :before-close="cancel" :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="100px" >
        <el-row :gutter="20">
          <el-col :span="16">
            <el-form-item label="二维码名称" prop="name">
              <el-input v-model.trim="form.name" placeholder="请输入二维码名称" @input="forceUpdate" maxlength="15" show-word-limit />
            </el-form-item>
          </el-col>
          <el-col :span="16">
            <el-form-item label="渠道名称" prop="topChannelId">
              <el-select v-model.trim="form.topChannelId"  placeholder="请选择渠道名称"   @input="forceUpdate" >
                <el-option
                  v-for="dict in channelList"
                  :key="dict.id"
                  :label="dict.name"
                  :value="dict.id"/>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" v-if="!loading">确 定</el-button>
        <el-button :loading="loading" type="primary" @click="submitForm" v-else>提交中...</el-button>
        <el-button @click="cancel" plain>取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { addCode, updataCode, delCode, listCode, channlPageCode, getBs } from "@/api/recharge/qrCode";
import QRCode from 'qrcode'
export default {
  name: "admin",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 参数表格数据
      adminList: [],
      // 充值渠道下拉
      channelList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        current: 1,
        size: 10,
        name: undefined,
        topChannelName: undefined,
      },
      // 表单参数
      form: {
        name:'',
        topChannelId:''
      },
      codeUrl:null,
      // 表单校验
      rules: {
        name: [
          { required: true, message: "二维码名称不能为空", trigger: "blur" }
        ],
        topChannelName: [
          { required: true, message: "渠道名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    channlPageCode().then(response => this.channelList = response.data);
  },
  methods: {
    forceUpdate(){ //重置form
      this.form = JSON.parse(JSON.stringify(this.form));
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true;
      listCode(this.addDateRange(this.queryParams)).then(response => {
        var data = response.data.records
        for(let i =0;i<data.length; i++){
          QRCode.toDataURL(data[i].qrPath,{type: "image/png", //类型
            quality: 0.5, //图片质量A Number between 0 and 1
            width: 500, //高度
            height: 500, //宽度
            errorCorrectionLevel: "L", //容错率
            margin: 1, //外边距
            color: {
              dark: "#000000", //前景色
              light: "#ffffff" //背景色
            }}
          ).then(imgData => {
            data[i].qrPath = imgData
          });
        }
        this.adminList = data;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        ids: undefined,
        name: undefined,
        topChannelName: undefined,
        topChannelId:undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加参数";
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      Object.assign(this.form, row.id ? this.adminList.find(val=>val.id === row.id) : this.adminList.find(val=>val.id === this.ids[0]))
      this.open = true;
      this.title = "修改参数";
    },
    /** 提交按钮 */
    submitForm(row) {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loading = true
          if (this.form.id != undefined) {
            updataCode(this.form).then(response => {
              this.loading = false
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).catch(()=>{
              this.loading = false,
              this.open = false
            })
          } else {
            addCode(this.form).then(response => {
              this.loading = false
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).catch(()=>{
              this.loading = false,
              this.open = false
            })
          }
        }
      });
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function(res) {
          return delCode(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
  }
};
</script>
